package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class LoginOutActionModelImpl implements ILoginOutActionModel {

    private OnLoginOutListener listener;

    public LoginOutActionModelImpl(OnLoginOutListener loginOutListener) {
        this.listener = loginOutListener;
    }

    /**
     * 数据回调接口
     */
    public interface OnLoginOutListener {
        void onSuccess(ActionResultBean resultBean);

        void onFailure(Throwable throwable);
    }


    @Override
    public Subscription sendRetrofitRequest() {
        Observable<ActionResultBean> observable = RetrofitServiceManager.getLoginOutResult();
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<ActionResultBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(ActionResultBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }
}
